// Modified SpoutSender 
// Original source code: http://spout.zeal.co

//
//          Spout Sender
//
//      Sharing image frames between applications
//      by Opengl/directx texture or memory map sharing
//
//      Demonstrates drawing onto the Processing
//      screen and sending out as a shared texture
//      to a Spout receiver.
//
//      Based on a Processing example sketch by by Dave Bollinger
//      http://processing.org/examples/texturecube.html
//
//      See Spout.pde for function details
//


import processing.video.*;

Capture cam;

int LARGEUR = 1280;
int HAUTEUR = 720;
String CAMERA = "Logitech HD Pro Webcam C920";
int FPS = 30;


// DECLARE A SPOUT OBJECT HERE
Spout spout;


void setup() {

  
  size(LARGEUR, HAUTEUR, P3D);

  String[] cameras = Capture.list();
  
  if (cameras.length == 0) {
    println("There are no cameras available for capture.");
    exit();
  } else {
    println("Available cameras:");
    for (int i = 0; i < cameras.length; i++) {
      println(cameras[i]);
    }
    
    
    
    

    // The camera can be initialized directly using an 
    // element from the array returned by list():
    //    cam = new Capture(this, cameras[0]);
    cam = new Capture(this, LARGEUR, HAUTEUR, CAMERA, FPS);
    cam.start();     
  }      
  


  textureMode(NORMAL);
  fill(255);
  
  // CREATE A NEW SPOUT OBJECT HERE
  spout = new Spout();

  // INITIALIZE A SPOUT SENDER HERE
  spout.initSender("Processing 3", width, height);
  
  // Alternative for memoryshare only
  // spout.initSender(width, height);
  
} 

void draw()  { 

  if (cam.available() == true) {
    cam.read();
  }
  image(cam, 0, 0);



  
  // SEND A SHARED TEXTURE HERE
  spout.sendTexture();
  
}


// over-ride exit to release sharing
void exit() {
  // CLOSE THE SPOUT SENDER HERE
  spout.closeSender();
  super.exit(); // necessary
} 




